<?php

include_once("config.php");
include_once( INSTALL_PATH . "/DBRecord.class.php" );
include_once( INSTALL_PATH . "/Smarty/Smarty.class.php" );
include_once( INSTALL_PATH . "/reclib.php" );
include_once( INSTALL_PATH . "/Settings.class.php" );

// 設定ファイルの有無を検査する
if( ! file_exists( INSTALL_PATH."/settings/config.xml") ) {
    header( "Content-Type: text/html;charset=utf-8" );
    exit( "<script type=\"text/javascript\">\n" .
          "<!--\n".
         "window.open(\"install/step1.php\",\"_self\");".
         "// -->\n</script>" );
}

$settings = Settings::factory();

// 現在の時間
$now_time = time();

// パラメータの処理
// 表示する長さ（時間）
$program_length = $settings->program_length;
if( isset( $_GET['length']) ) $program_length = (int) $_GET['length'];

// 地上=GR/BS=BS
$type = "GR";
if( isset( $_GET['type'] ) ) $type = $_GET['type'];

// 番組表
// 表示チャンネル
$programs = array();
$single_ch = $single_ch_selects = null;
$channel_map = array();
if (isset($_GET['ch'] )) {
	switch(strtoupper(substr($_GET['ch'], 0, 2))) {
		case 'GR':
			$type = "GR";
			$single_ch = $GR_CHANNEL_MAP[$_GET['ch']];
			break;
		case 'CS':
			$type = "CS";
			$single_ch =  $CS_CHANNEL_MAP[$_GET['ch']];
			break;
		case 'BS':
			$type = "BS";
			$single_ch =  $BS_CHANNEL_MAP[$_GET['ch']];
	}
	// チャンネルセレクタ
	$crec = DBRecord::createRecords( CHANNEL_TBL, "WHERE type='$type' AND skip=0" );
	$single_ch_selects = array();
	foreach( $crec as $val ) {
		array_push( $single_ch_selects, array(
			'name' => $val->name,
			'type' => $val->type,
			'channel_disc' => $val->channel_disc,
			'channel' => $val->channel
		));
	}
	// echo('<pre>');
	// print_r($single_ch_selects);
	// echo('</pre>');exit;
	
} else {
	if( $type == "GR" ) $channel_map = $GR_CHANNEL_MAP;
	else if( $type == "BS" ) $channel_map = $BS_CHANNEL_MAP;
	else if( $type == "CS" ) $channel_map = $CS_CHANNEL_MAP;
}

// 現在の時間
$top_time = mktime( date("H"), 0 , 0 );
if( isset( $_GET['time'] ) ) {
	if( sscanf( $_GET['time'] , "%04d%2d%2d%2d", $y, $mon, $day, $h ) == 4 ) {
		// シングルチャンネル時は開始を今日に変更
		if ( $single_ch ) {
			$day = (int)date("j");
			if ( (int)$h > (int)date("G") ) { $day--; }
			$top_time = mktime($h, 0, 0, date("n"), $day, date("Y"));
		} else {
			$tmp_time = mktime( $h, 0, 0, $mon, $day, $y );
			if( ($tmp_time < ($top_time + 3600 * 24 * 8)) && ($tmp_time > ($top_time - 3600 * 24 * 8)) )
				$top_time = $tmp_time;
		}
	}
}
$last_time = $top_time + 3600 * $program_length;
// 時刻欄
$iMax = $single_ch?24:$program_length;
for( $i = 0 ; $i < $iMax; $i++ ) {
	$tvtimes[$i] = date("H", $top_time + 3600 * $i );
}

$st = 0;
$prec = null;
try {
	$prec = new DBRecord(PROGRAM_TBL);
}
catch( Exception $e ) {
	exit('プログラムテーブルが存在しないようです。インストールをやり直してください.');
}
$num_ch = 0;
$channel_map_keys = array_keys($channel_map);
for ( $i = 0; $i < ($single_ch?8:count($channel_map)); $i++ ) {
	if ( $single_ch ) {
		$channel_disc = $_GET['ch'];
		$channel = $single_ch;
		$ch_full_duration = $st * 24*60*60;
		$ch_top_time = $top_time + $ch_full_duration;
		$ch_last_time = $ch_top_time + 24*60*60;
	} else {
		$channel_disc = $channel_map_keys[$i];
		$channel = $channel_map[$channel_disc];
		$ch_full_duration = 0;
		$ch_top_time = $top_time;
		$ch_last_time = $last_time;
	}
	$prev_end = $top_time + $ch_full_duration;
 	try {
		$num = 0;
		$crec = new DBRecord( CHANNEL_TBL, "channel_disc", $channel_disc );
		$programs[$st]["skip"] = $crec->skip;
		if( $crec->skip == 0 ) $num_ch++;
		$programs[$st]["channel_disc"] = $channel_disc;
		$programs[$st]["station_name"]  = $crec->name;
		// シングルチャンネル用
		if ( $single_ch ) {
			$single_ch_name = $crec->name;
			$programs[$st]["start_time"]  = $ch_top_time;
			$programs[$st]["start_time_dw"]  = date("w", $ch_top_time ).'';
			$programs[$st]["link"] = 'index.php?type='.$type.'&time='.date( "Ymd", $top_time + 24 * 3600 * $i) . date("H" , $top_time );	
		}

		$programs[$st]["sid"] = $crec->sid;
		$programs[$st]["ch_hash"] = md5($channel_disc);
		
		$reca = $prec->fetch_array( "channel_disc", $channel_disc,
		                                  "endtime > '".toDatetime($ch_top_time)."' ".
		                                  "AND starttime < '". toDatetime($ch_last_time)."' ".
		                                  "ORDER BY starttime ASC "
		                               );
		$programs[$st]['list'] = array();
		foreach( $reca as $prg ) {
			$prg_starttime = $start = strtotime($prg['starttime']);
			$prg_endtime = strtotime($prg['endtime']);
			// 前プログラムとの空きを調べる
			if( ($prg_starttime - $prev_end) > 0 ) {
				$height = ($prg_starttime-$prev_end) * $settings->height_per_hour / 3600;
				$programs[$st]['list'][$num]['category_none'] = "none";
				$programs[$st]['list'][$num]['height'] = $height;
				$programs[$st]['list'][$num]['title'] = "";
				$programs[$st]['list'][$num]['starttime'] = "";
				$programs[$st]['list'][$num]['description'] = "";
				if ($prg_starttime <= $now_time) {
					$programs[$st]['list'][$num]['prg_pass'] = 1;
				} else {
					$programs[$st]['list'][$num]['prg_pass'] = 0;
				}
				$num++;
			}
			$prev_end = $prg_endtime;
			
			$height = $prg_endtime - $prg_starttime;
			// $top_time より早く始まっている番組
			if( $prg_starttime < $ch_top_time ) {
				$height = $prg_endtime - $ch_top_time;
			}
			// $last_time より遅く終わる番組
			if( $prg_endtime > $ch_last_time ) {
				$height = $height - ($prg_endtime - $ch_last_time);
			}
			$height = $height * $settings->height_per_hour / 3600;
			
			// プログラムを埋める
			$cat = new DBRecord( CATEGORY_TBL, "id", $prg['category_id'] );
			$programs[$st]['list'][$num]['category_name'] = $cat->name_en;
			$programs[$st]['list'][$num]['height'] = $height;
			$programs[$st]['list'][$num]['title'] = $prg['title'];
			$programs[$st]['list'][$num]['starttime'] = date("H:i", $start )."" ;
			$programs[$st]['list'][$num]['description'] = $prg['description'];
			$programs[$st]['list'][$num]['prg_start'] = str_replace( "-", "/", $prg['starttime']);
			$programs[$st]['list'][$num]['duration'] = "" . (toTimestamp($prg['endtime']) - toTimestamp($prg['starttime']));
			$programs[$st]['list'][$num]['channel'] = ($prg['type'] == "GR" ? "地上D" : "BS" ) . ":". $prg['channel'] . "ch";
			$programs[$st]['list'][$num]['id'] = "" . ($prg['id']);
			$programs[$st]['list'][$num]['rec'] = DBRecord::countRecords(RESERVE_TBL, "WHERE complete = '0' AND program_id = '".$prg['id']."'" );
			// 放送中、放送終了判定
			if (strtotime($prg['starttime']) <= $now_time) {
				if (strtotime($prg['endtime']) >= $now_time) {
					$programs[$st]['list'][$num]['prg_pass'] = 2;
				} else {
					$programs[$st]['list'][$num]['prg_pass'] = 1;
				}
			} else {
				$programs[$st]['list'][$num]['prg_pass'] = 0;
			}
			$num++;
		}
	}
	 catch( exception $e ) {
		$num_ch++;	// epgの無いチャンネル対応
//		exit( $e->getMessage() );
//		何もしない
 	}
 	// 空きを埋める
	if( ($ch_last_time - $prev_end) > 0 ) {
		$height = ($ch_last_time - $prev_end) * $settings->height_per_hour / 3600;
		$height = $height;
		$programs[$st]['list'][$num]['category_name'] = "none";
		$programs[$st]['list'][$num]['height'] = $height;
		$programs[$st]['list'][$num]['title'] = "";
		$programs[$st]['list'][$num]['starttime'] = "";
		$programs[$st]['list'][$num]['description'] = "";
		if ($prev_end <= $now_time) {
			$programs[$st]['list'][$num]['prg_pass'] = 1;
		} else {
			$programs[$st]['list'][$num]['prg_pass'] = 0;
		}
		$num++;
 	}
	$st++;
}

// 局の幅
$ch_set_width = (int)($settings->ch_set_width);
// 全体の幅
$chs_width = $ch_set_width * $num_ch;

// GETパラメタ
$get_param = $_SERVER['SCRIPT_NAME'] . "?type=".$type."&length=".$program_length."";

$smarty = new Smarty();

// カテゴリ一覧
$crec = DBRecord::createRecords( CATEGORY_TBL );
$cats = array();
$num = 0;
foreach( $crec as $val ) {
	$cats[$num]['name_en'] = $val->name_en;
	$cats[$num]['name_jp'] = $val->name_jp;
	$num++;
}
$smarty->assign( "cats", $cats );


// タイプ選択
$types = array();
$i = 0;
if( $settings->bs_tuners != 0 ) {
	$types[$i]['selected'] = $type == "BS" ? 'class="selected"' : "";
	$types[$i]['link'] = $_SERVER['SCRIPT_NAME'] . "?type=BS&length=".$program_length."&time=".date( "YmdH", $top_time);
	$types[$i]['name'] = "BS";
	$i++;

	// CS
	if ($settings->cs_rec_flg != 0) {
		$types[$i]['selected'] = $type == "CS" ? 'class="selected"' : "";
		$types[$i]['link'] = $_SERVER['SCRIPT_NAME'] . "?type=CS&length=".$program_length."&time=".date( "YmdH", $top_time);
		$types[$i]['name'] = "CS";
		$i++;
	}
}
if( $settings->gr_tuners != 0 ) {
	$types[$i]['selected'] = $type == "GR" ? 'class="selected"' : "";
	$types[$i]['link'] = $_SERVER['SCRIPT_NAME'] . "?type=GR&length=".$program_length."&time=".date( "YmdH", $top_time);
	$types[$i]['name'] = "地上デジタル";
	$i++;
}
$smarty->assign( "types", $types );

// 日付選択
$days = array();
$day = array();
$day['d'] = "昨日";
$day['link'] = $get_param . "&time=". date( "YmdH", time() - 3600 *24 );
$day['ofweek'] = null;
$day['selected'] = $top_time < mktime( 0, 0 , 0) ? 'class="selected"' : '';

array_push( $days , $day );
$day['d'] = "現在";
$day['link'] = $get_param;
$day['ofweek'] = null;
$day['selected'] = "";
array_push( $days, $day );
for( $i = 0 ; $i < 8 ; $i++ ) {
	$day['d'] = "".date("d", time() + 24 * 3600 * $i ) . "日";
	$day['link'] = $get_param . "&time=".date( "Ymd", time() + 24 * 3600 * $i) . date("H" , $top_time );
	$day['ofweek'] = date( "w", time() + 24 * 3600 * $i );
	$day['selected'] = date("d", $top_time) == date("d", time() + 24 * 3600 * $i ) ? 'class="selected"' : '';
	array_push( $days, $day );
}
$smarty->assign( "days" , $days );

// 時間選択
$toptimes = array();
for( $i = 0 ; $i < 24; $i+=4 ) {
	$tmp = array();
	$tmp['hour'] = sprintf( "%02d:00", $i );
	$tmp['link'] = ($single_ch?"{$_SERVER['SCRIPT_NAME']}?ch=$channel_disc":$get_param) . "&time=".date("Ymd", $top_time ) . sprintf("%02d", $i );
	array_push( $toptimes, $tmp );
}
$smarty->assign( "toptimes" , $toptimes );

$smarty->assign( "tvtimes", $tvtimes );
$smarty->assign( "programs", $programs );
$smarty->assign( "ch_set_width", (int)($settings->ch_set_width) );
$smarty->assign( "chs_width", $chs_width );
$smarty->assign( "height_per_hour", $settings->height_per_hour );
$smarty->assign( "height_per_min", $settings->height_per_hour / 60 );
$smarty->assign( "num_ch", $num_ch );
$smarty->assign( "num_all_ch" , count( $channel_map ) );
$smarty->assign( "single_ch", $single_ch );
$smarty->assign( "single_ch_disc", $channel_disc );
$smarty->assign( "single_ch_selects", $single_ch_selects );

$sat_type = array('GR' => '地上デジタル', 'BS' => 'BSデジタル', 'CS' => 'CSデジタル');
$sitetitle = date( "Y", $top_time ) . "年" . date( "m", $top_time ) . "月" . date( "d", $top_time ) . "日". date( "H", $top_time ) .
              "時～".$sat_type[$type].($single_ch?":$single_ch_name ":"")."番組表";

$smarty->assign("sitetitle", $sitetitle );

$smarty->assign("top_time", str_replace( "-", "/" ,toDatetime($top_time)) );
$smarty->assign("last_time", str_replace( "-", "/" ,toDatetime($last_time)) );


$smarty->display("index.html");
?>

